#include "string.h"
#define Cont_threshold 3
#define thgain 1
#define thgain2 1

char recieve_data[80];//受信可能文字数
char cmpstr[10];//チェック用文字列格納用
int chkstr[17];//17入力 (X,Y,Z,rZ,B1~~~B12,POV)
int recieve_cont = 0;//文字カウント用変数
int vector0 = 0;
int vector1 = 0;
int vector2 = 0;
int vector3 = 0;
int vector4 = 0;
int vector5 = 0; 
bool recieve_end = false;//命令が更新されているか（文字列の終端まで到達しているか）
bool USB_Communication = false;//電話線接続モード（USB時接続テスト時にはTrueにする）

void setup() {
  // put your setup code here, to run once:

  pinMode(A0,OUTPUT);//Motor1
  pinMode(A1,OUTPUT);//Motor2
  pinMode(A2,OUTPUT);//Motor3
  pinMode(A3,OUTPUT);//Motor4
  pinMode(A4,OUTPUT);//Motor5
  pinMode(A5,OUTPUT);//Motor6
  
  if(USB_Communication){ //接続方法は何にする？
    Serial.begin(115200);
  }else{
    Serial1.begin(115200);
  }

    MotorDrive(2,0);
    MotorDrive(3,0);
    MotorDrive(4,0);
    MotorDrive(5,0);
    MotorDrive(1,0);
    MotorDrive(6,0);
}

void loop() {
  
  // put your main code here, to run repeatedly:
  SerialRead();
  if(recieve_end){//SerialRead関数で命令系が受信されるとフラグが立ち、こちらのループに移動する。
  
  //動作する内容を変更する
  //コントローラから得られた数値から機体を動作させるための推力値に変換する
  //PC上のソフトから得られたコントローラの値はSerialReadで読みこまれ、Chkstr[]に格納される。対応は下記。
  //17項目を読み込み，int型で格納する
  //chkstr[0]=左軸横（右が正）    //chkstr[1]=左軸縦（上が正）  //chkstr[2]=右軸縦（上が正）    //chkstr[3]=右軸横（右が正）
  //chkstr[4]=A（押下で1)         //chkstr[5]=B（押下で1)       //chkstr[6]=X（押下で1)         //chkstr[7]=Y（押下で1)
  //chkstr[8]=LB                  //chkstr[9]=RB                //chkstr[10]=Back               //chkstr[11]=Start
  //chkstr[12]=左軸おしこみ       //chkstr[13]=右軸おしこみ     //chkstr[14]=NC                 //chkstr[15]=NC
  //chkstr[16]=方向キー　デフォルト-1 時計回り8方向　0-4500-9000-13500-18000-22500-27000-31500

    //コントローラ命令を書き込む部分ここから
    if ((Cont_threshold > abs(chkstr[0])) && (Cont_threshold > abs(chkstr[1]))){
        vector0 = (int)(chkstr[2] * thgain);
        vector1 = (int)(chkstr[2] * thgain);
        vector2 = (int)(chkstr[2] * thgain);
        vector3 = (int)(chkstr[2] * thgain);
    }else{
        vector0 = (int)(chkstr[2] * thgain + map((((-1*  chkstr[0] * thgain2) + (-1*  chkstr[1] * thgain2))),-511,511,-255,255));
        vector1 = (int)(chkstr[2] * thgain + map((((     chkstr[0] * thgain2) + (-1*  chkstr[1] * thgain2))),-511,511,-255,255));
        vector2 = (int)(chkstr[2] * thgain + map((((     chkstr[0] * thgain2) + (     chkstr[1] * thgain2))),-511,511,-255,255));
        vector3 = (int)(chkstr[2] * thgain + map((((-1*  chkstr[0] * thgain2) + (     chkstr[1] * thgain2))),-511,511,-255,255));     
    }
    //M1はvector4,M6はvector5に代入すると回転する（入力値は-255～255）

    
    //コントローラ命令を書き込む部分ここまで

    //限界値を超えた場合は足切り
    vector0 = constrain(vector0,-255,255);
    vector1 = constrain(vector1,-255,255);
    vector2 = constrain(vector2,-255,255);
    vector3 = constrain(vector3,-255,255);
    vector4 = constrain(vector4,-255,255);
    vector5 = constrain(vector5,-255,255);

    //格納したデータを処理して出力
    MotorDrive(2,vector0); //M2 
    MotorDrive(3,vector1); //M3
    MotorDrive(4,vector2); //M4
    MotorDrive(5,vector3); //M5
    
    MotorDrive(1,vector4);//M1 デフォルト無効
    MotorDrive(6,vector5);//M6 デフォルト無効
    
  }else{
  //必要な処理があれば追加
  }
  
}

//モータを回転させる関数
//接続されたモータ（1～4），回転数(-254～254)で指定する
void MotorDrive(char motornom,int motorspeed){
  switch(motornom){
    case 1://活用にはバイパスが必要
       analogWrite(3,(-1) * motorspeed);
      if(motorspeed <= 0){
        digitalWrite(A0,LOW);
      }else{
        digitalWrite(A0,HIGH);
      }
      break;
    case 2:
      analogWrite(5,(-1) * motorspeed);
      if(motorspeed <= 0){
        digitalWrite(A1,LOW);
      }else{
        digitalWrite(A1,HIGH);
      }
      break;
    case 3:
      analogWrite(6,(-1) * motorspeed);
      if(motorspeed <= 0){
        digitalWrite(A2,LOW);
      }else{
        digitalWrite(A2,HIGH);
      }
      break;
    case 4:
      analogWrite(9,(-1) * motorspeed);
      if(motorspeed <= 0){
        digitalWrite(A3,LOW);
      }else{
        digitalWrite(A3,HIGH);
      }
      break;
    case 5:
      analogWrite(10,(-1) * motorspeed);
      if(motorspeed <= 0){
        digitalWrite(A4,LOW);
      }else{
        digitalWrite(A4,HIGH);
      }
      break;
     case 6:
      analogWrite(11,(-1) * motorspeed);
      if(motorspeed <= 0){
        digitalWrite(A5,LOW);
      }else{
        digitalWrite(A5,HIGH);
      }
      break;
   }
}

//文字列を受信する関数
void SerialRead(){
  if(USB_Communication){ //接続方法は何にする？
    if(Serial.available()){//Serialの受信があったか確認する
        recieve_data[recieve_cont] = Serial.read();//受信した文字列を読み込む（1字/回）    
        if(recieve_cont > 50 || recieve_data[recieve_cont] == '\n'){//受信した文字数が50字or受信した文字が"\n”であるか？(\nとはC言語における文字列の改行文字)
          //下2行のコメントを外すと受信した文字列を[Recieve = "文字列"]という形で返信する
          //Serial1.write("Recieve = ");
          //Serial1.write(recieve_data);
          recieve_cont = 0;//文字列を入手したら文字数カウントを初期化する
          
          //文字列を切り取り，各値を確認する
          chkstr[0] = atoi(strtok(recieve_data,","));//命令セット文字列を格納
          for(int counter1 = 1;counter1 < 16;counter1++) chkstr[counter1] = atoi(strtok(NULL,","));//受け取る数値は右(a1,a2,a3,a4,p1,p2,p3,p4)
          memset(( void * )recieve_data ,NULL, sizeof(recieve_data));
          recieve_end = true;
    
        }else{//上の条件を満たさなかった場合は一文字ずらす．
          //Serial.write(recieve_data); //ここのコメントを外すと受信データを逐次送信する．
          recieve_cont++;
          recieve_end = false;
        }
    }
  
  }else{
    if(Serial1.available()){//Serialの受信があったか確認する
        recieve_data[recieve_cont] = Serial1.read();//受信した文字列を読み込む（1字/回）    
        if(recieve_cont > 50 || recieve_data[recieve_cont] == '\n'){//受信した文字数が50字or受信した文字が"\n”であるか？(\nとはC言語における文字列の改行文字)
          //下2行のコメントを外すと受信した文字列を[Recieve = "文字列"]という形で返信する
          //Serial1.write("Recieve = ");
          //Serial1.write(recieve_data);
          recieve_cont = 0;//文字列を入手したら文字数カウントを初期化する
          
          //文字列を切り取り，各値を確認する
          chkstr[0] = atoi(strtok(recieve_data,","));//命令セット文字列を格納
          for(int counter1 = 1;counter1 < 16;counter1++) chkstr[counter1] = atoi(strtok(NULL,","));//受け取る数値は右(a1,a2,a3,a4,p1,p2,p3,p4)
          memset(( void * )recieve_data ,NULL, sizeof(recieve_data));
          recieve_end = true;
    
        }else{//上の条件を満たさなかった場合は一文字ずらす．
          //Serial1.write(recieve_data); //ここのコメントを外すと受信データを逐次送信する．
          recieve_cont++;
          recieve_end = false;
        }
    }
  }
}
